﻿#region Licence
// Copyright (c) 2011 BAX Services Bartosz Adamczewski
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CSpec.Tests.Examples.Calculator
{
    /// <summary>
    /// Calculator project to test CSpec on 
    /// a (semi) real project, rater then 
    /// just testing methods.
    /// </summary>
    public class Calc : ICalc
    {
        /// <summary>
        /// Initalisation constructor
        /// resets the Total value.
        /// </summary>
        public Calc()
        {
            Total = 0;
        }

        /// <summary>
        /// Adds a value to the total
        /// </summary>
        /// <param name="a"></param>
        /// <returns></returns>
        public int Sum(int a)
        {
            Total += a;
            return Total;
        }

        /// <summary>
        /// Substracts a value from total
        /// </summary>
        /// <param name="a"></param>
        /// <returns></returns>
        public int Sub(int a)
        {
            Total -= a;
            return Total;
        }

        /// <summary>
        /// Takes a total to a power of a given value
        /// </summary>
        /// <param name="a"></param>
        /// <returns></returns>
        public int Pow(int a)
        {
            Total = (int)Math.Pow(Total, a);
            return Total;
        }

        /*
         * There are many things that can go wrong with the div 
         * method in this context.
         * 
         * So we will check if our crappy metthod will throw exceptions.
         */

        /// <summary>
        /// Divides the total by a given value.
        /// </summary>
        /// <param name="a"></param>
        /// <returns></returns>
        public int Div(int a)
        {
            Total = Total / a;
            return Total;
        }

        /// <summary>
        /// Gets the total value
        /// </summary>
        public int Total
        {
            get;
            set;
        }

        /// <summary>
        /// Rests the total
        /// </summary>
        public void Reset()
        {
            Total = 0;
        }
    }
}
