﻿#region Licence
// Copyright (c) 2011 BAX Services Bartosz Adamczewski
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CSpec.Shell.Display;

namespace CSpec.Shell.Execution
{
    /// <summary>
    /// Describes an additional attribute for action that will need to be performend if present.
    /// </summary>
    public interface ICommand : IDescriptor
    {
        /// <summary>
        /// Executes the specifid command.
        /// </summary>
        /// <param name="console"></param>
        /// <param name="actionParams"></param>
        void Execute(CSpecConsole console, params object[] actionParams);
        /// <summary>
        /// Gets the priority of the command.
        /// </summary>
        /// <remarks>
        /// Prioririty is used to tell the Action that it 
        /// need's to be processed first or last.
        /// </remarks>
        int Priority { get; }
    }
}
