﻿#region Licence
// Copyright (c) 2011 BAX Services Bartosz Adamczewski
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CSpec.Proxy
{
    /// <summary>
    /// Used to trace and log states of proxy object
    /// that must implement an InterfaceType.
    /// </summary>
    /// <remarks>
    /// The proxy is used for more advanced features of Cspec like flow control
    /// or exception control etc.
    /// </remarks>
    public class ProxyTrace
    {
        /// <summary>
        /// Gets/Sets the target object (the object that is't beeing tested)
        /// </summary>
        public object Target { get; set; }
        /// <summary>
        /// Gets/Sets the list that contains detailed information about method calls
        /// </summary>
        public List<ProxyMethod> MethodCalls { get; set; }
        /// <summary>
        /// Default contructor, that initializes the method calls list.
        /// </summary>
        public ProxyTrace()
        {
            MethodCalls = new List<ProxyMethod>();
        }
    }
}
